package provider

import (
	. "code.hoteas.com/golang/hotime"
	. "code.hoteas.com/golang/hotime/common"
)

var CompanyCtr = Ctr{
	"info": func(that *Context) {
		if that.Session("salesman_id").Data == nil {
			that.Display(2, "没有登录")
			return
		}

		id := ObjToInt(that.Req.FormValue("id"))

		if id == 0 {
			that.Display(3, "请求参数异常")
			return
		}

		res := that.Db.Get("company", "*", Map{"id": id})
		if res == nil {
			that.Display(4, "找不到企业")
			return
		}
		//先不做限制
		//if res.GetCeilInt("salesman_id")!=that.Session("salesman_id").ToCeilInt(){
		//	that.Display(4,"不是你的企业")
		//	return
		//}

		res["technology_center_flag"] = ObjToSlice(res["technology_center_flag"])
		res["engineering_center_flag"] = ObjToSlice(res["engineering_center_flag"])
		res["engineering_laboratory_flag"] = ObjToSlice(res["engineering_laboratory_flag"])
		res["key_laboratory_flag"] = ObjToSlice(res["key_laboratory_flag"])
		res["industrial_design_center_flag"] = ObjToSlice(res["industrial_design_center_flag"])

		that.Display(0, res)
	},
	"edit": func(that *Context) {
		if that.Session("salesman_id").Data == nil {
			that.Display(2, "没有登录")
			return
		}

		id := ObjToInt(that.Req.FormValue("id"))

		if id == 0 {
			that.Display(3, "请求参数异常")
			return
		}

		company := that.Db.Get("company", "*", Map{"id": id})
		delete(company, "id")
		delete(company, "salesman_id")
		delete(company, "provider_id")
		delete(company, "user_id")
		delete(company, "del_flag")
		delete(company, "state")
		delete(company, "create_time")
		delete(company, "modify_time")
		data := Map{}
		for k, _ := range company {
			if that.Req.Form[k] != nil {
				if k == "technology_center_flag" || k == "engineering_center_flag" || k == "engineering_laboratory_flag" || k == "key_laboratory_flag" || k == "industrial_design_center_flag" {
					data[k] = ObjToStr(that.Req.Form[k])
				} else {
					data[k] = that.Req.FormValue(k)
				}

			}
		}

		that.Db.Update("company", company, Map{"id": id})

		that.Display(0, "更新成功")

	},
}
